/* Some utility functions (not part of the algorithm) */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Function to return the maximum of two variables */
double maximum (double a, double b)
{
    if (a>b)
    {
        return(a);
    }
    return (b);
}

/* Function to return the minimum of two variables */
double minimum (double a, double b)
{
    if (a<b)
    {
        return (a);
    }
    return (b);
}

/* Function to return the minimum of an array */
double array_minimum (double *a, int array_length)
{
	int i;
	double m = a[0];
	for (i=1; i<array_length; ++i)
	{
		if (a[i] < m)
		{
			m = a[i];
		}
	}
	return m;
}

/* Function to compute the norm of a vector */
double array_norm (double *a, int array_length)
{
	int i;
	double n = 0;
	for (i=0; i<array_length; ++i)
	{
		n += a[i]*a[i];
	}
	return sqrt(n);
}
