/* Test problem definitions */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include <assert.h>

# include "global.h"
# include "wfg.h"
# include "rand.h"

/* # define sch1 */
/* # define sch2 */
/* # define fon */
/* # define kur */
/* # define pol */
/* # define vnt */
/* # define zdt1 */
/* # define mzdt1 */
/* # define szdt1 */
/* # define zdt2 */
/* # define szdt2 */
/* # define zdt3 */
/* # define zdt4 */
/* # define zdt5 */
/* # define zdt6 */
/* # define szdt6 */
/* # define ozdt6 */
/* # define bnh */
/* # define osy */
/* # define srn */
/* # define tnk */
/* # define ctp1 */
/* # define ctp2 */
/* # define ctp3 */
/* # define ctp4 */
/* # define ctp5 */
/* # define ctp6 */
/* # define ctp7 */
/* # define ctp8 */
/* # define dtlz1 */
/* # define dtlz2 */
/* # define mdtlz2 */
/* # define dtlz3 */
/* # define dtlz4 */
/* # define dtlz5 */
/* # define dtlz6 */
/* # define dtlz7 */
/* # define dtlz8 */
/* # define dtlz9 */
/* # define wfg1 */
/* # define wfg2 */
/* # define wfg3 */
/* # define wfg4 */
/* # define wfg5 */
/* # define wfg6 */
/* # define wfg7 */
/* # define wfg8 */
/* # define wfg9 */
/* # define deb3dk_1 */
/* # define deb2dk_4 */

# define dtlz8


/*  Test problem SCH1
    # of real variables = 1
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef sch1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = pow(xreal[0],2.0);
    obj[1] = pow((xreal[0]-2.0),2.0);
    /*obj[1] += 0.75*obj[0];*/
    return;
}
#endif

/*  Test problem SCH2
    # of real variables = 1
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef sch2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    if (xreal[0]<=1.0)
    {
        obj[0] = -xreal[0];
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    if (xreal[0]<=3.0)
    {
        obj[0] = xreal[0]-2.0;
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    if (xreal[0]<=4.0)
    {
        obj[0] = 4.0-xreal[0];
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    obj[0] = xreal[0]-4.0;
    obj[1] = pow((xreal[0]-5.0),2.0);
    return;
}
#endif

/*  Test problem FON
    # of real variables = n
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef fon
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double s1, s2;
    int i;
    s1 = s2 = 0.0;
    for (i=0; i<nreal; i++)
    {
        s1 += pow((xreal[i]-(1.0/sqrt((double)nreal))),2.0);
        s2 += pow((xreal[i]+(1.0/sqrt((double)nreal))),2.0);
    }
    obj[0] = 1.0 - exp(-s1);
    obj[1] = 1.0 - exp(-s2);
    return;
}
#endif

/*  Test problem KUR
    # of real variables = 3
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef kur
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    int i;
    double res1, res2;
    res1 = -0.2*sqrt((xreal[0]*xreal[0]) + (xreal[1]*xreal[1]));
    res2 = -0.2*sqrt((xreal[1]*xreal[1]) + (xreal[2]*xreal[2]));
    obj[0] = -10.0*( exp(res1) + exp(res2));
    obj[1] = 0.0;
    for (i=0; i<3; i++)
    {
        obj[1] += pow(fabs(xreal[i]),0.8) + 5.0*sin(pow(xreal[i],3.0));
    }
    return;
}
#endif

/*  Test problem POL
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef pol
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double a1, a2, b1, b2;
    a1 = 0.5*sin(1.0) - 2.0*cos(1.0) + sin(2.0) - 1.5*cos(2.0);
    a2 = 1.5*sin(1.0) - cos(1.0) + 2.0*sin(2.0) - 0.5*cos(2.0);
    b1 = 0.5*sin(xreal[0]) - 2.0*cos(xreal[0]) + sin(xreal[1]) - 1.5*cos(xreal[1]);
    b2 = 1.5*sin(xreal[0]) - cos(xreal[0]) + 2.0*sin(xreal[1]) - 0.5*cos(xreal[1]);
    obj[0] = 1.0 + pow((a1-b1),2.0) + pow((a2-b2),2.0);
    obj[1] = pow((xreal[0]+3.0),2.0) + pow((xreal[1]+1.0),2.0);
    return;
}
#endif

/*  Test problem VNT
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef vnt
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = 0.5*(xreal[0]*xreal[0] + xreal[1]*xreal[1]) + sin(xreal[0]*xreal[0] + xreal[1]*xreal[1]);
    obj[1] = (pow((3.0*xreal[0] - 2.0*xreal[1] + 4.0),2.0))/8.0 + (pow((xreal[0]-xreal[1]+1.0),2.0))/27.0 + 15.0;
    obj[2] = 1.0/(xreal[0]*xreal[0] + xreal[1]*xreal[1] + 1.0) - 1.1*exp(-(xreal[0]*xreal[0] + xreal[1]*xreal[1]));
    return;
}
#endif



/*  Test problem ZDT1
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
	int i;
	f1 = xreal[0];
	g = 0.0;
	for (i=1; i<30; i++)
	{
		g += xreal[i];
	}
	g = 9.0*g/29.0;
	g += 1.0;
	h = 1.0 - sqrt(f1/g);
	f2 = g*h;
	obj[0] = f1;
	obj[1] = f2;
	return;
}
#endif


#ifdef mzdt1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - pow((f1/g),0.2);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif


#ifdef szdt1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
	int nx=30;
	double g;
	double sum=0,psum=0,flag=0, f1, f2;
	double z[nx],zz[nx],p[nx];
	int i;
	double o[100]={0.950, 0.231, 0.607, 0.486, 0.891, 0.762, 0.457, 0.019, 0.821, 0.445, 0.615, 0.792, 0.922, 0.738, 0.176, 0.406, 0.936, 0.917, 0.410, 0.894, 0.058, 0.353, 0.813, 0.010, 0.139, 0.203, 0.199, 0.604, 0.272, 0.199, 0.015, 0.747, 0.445, 0.932, 0.466, 0.419, 0.846, 0.525, 0.203, 0.672, 0.838, 0.020, 0.681, 0.380, 0.832, 0.503, 0.710, 0.429, 0.305, 0.190, 0.193, 0.682, 0.303, 0.542, 0.151, 0.698, 0.378, 0.860, 0.854, 0.594, 0.497, 0.900, 0.822, 0.645, 0.818, 0.660, 0.342, 0.290, 0.341, 0.534, 0.727, 0.309, 0.839, 0.568, 0.370, 0.703, 0.547, 0.445, 0.695, 0.621, 0.795, 0.957, 0.523, 0.880, 0.173, 0.980, 0.271, 0.252, 0.876, 0.737, 0.137, 0.012, 0.894, 0.199, 0.299, 0.661, 0.284, 0.469, 0.065, 0.988};
	double d_l[100]={0.155, 0.119, 0.185, 0.064, 0.070, 0.203, 0.166, 0.151, 0.219, 0.083, 0.161, 0.057, 0.169, 0.072, 0.135, 0.114, 0.241, 0.129, 0.230, 0.181, 0.195, 0.058, 0.152, 0.107, 0.119, 0.219, 0.203, 0.212, 0.126, 0.238, 0.164, 0.236, 0.086, 0.087, 0.188, 0.244, 0.146, 0.124, 0.218, 0.196, 0.120, 0.140, 0.120, 0.207, 0.205, 0.114, 0.107, 0.228, 0.097, 0.208, 0.105, 0.120, 0.135, 0.196, 0.183, 0.111, 0.081, 0.236, 0.183, 0.171, 0.063, 0.160, 0.246, 0.091, 0.064, 0.188, 0.222, 0.082, 0.174, 0.114, 0.155, 0.209, 0.179, 0.130, 0.184, 0.200, 0.108, 0.143, 0.116, 0.155, 0.078, 0.189, 0.128, 0.171, 0.168, 0.226, 0.061, 0.250, 0.201, 0.226, 0.065, 0.194, 0.114, 0.159, 0.135, 0.239, 0.167, 0.204, 0.095, 0.091};
    double lamda_l[100]={3.236, 4.201, 2.701, 7.775, 7.148, 2.465, 3.020, 3.322, 2.285, 6.004, 3.106, 8.801, 2.956, 6.918, 3.708, 4.403, 2.077, 3.884, 2.171, 2.760, 2.567, 8.636, 3.299, 4.666, 4.208, 2.285, 2.469, 2.362, 3.963, 2.099, 3.052, 2.120, 5.809, 5.753, 2.654, 2.053, 3.427, 4.046, 2.297, 2.548, 4.151, 3.577, 4.165, 2.417, 2.445, 4.405, 4.668, 2.192, 5.147, 2.398, 4.743, 4.157, 3.710, 2.553, 2.733, 4.519, 6.159, 2.121, 2.738, 2.926, 7.918, 3.130, 2.034, 5.495, 7.846, 2.666, 2.253, 6.068, 2.881, 4.388, 3.220, 2.389, 2.791, 3.832, 2.711, 2.496, 4.624, 3.505, 4.297, 3.223, 6.428, 2.644, 3.920, 2.917, 2.978, 2.215, 8.138, 2.000, 2.490, 2.215, 7.711, 2.574, 4.395, 3.135, 3.705, 2.091, 3.003, 2.456, 5.241, 5.499};

	for(i=0;i<nx;i++)
	{
		z[i]=xreal[i]-o[i];
	}

	if ( z[0]>=0)
	{
		zz[0]=z[0];
		f1=zz[0]+1;
	}
	else
	{
		zz[0]= -lamda_l[0] * z[0];
		f1 = 2.0/(1+exp(z[0]/d_l[0])) * (zz[0]+1);
	}

	for(i=1;i<nx;i++)
	{
		p[i]=0;
		zz[i]=z[i];
		if (z[i]<0)
		{
			zz[i]= -lamda_l[i] * z[i];
			p[i]= -z[i]/d_l[i];
		}
		sum+=zz[i];
		psum = sqrt(pow(psum,2) + pow(p[i],2));
	}
	g = 1+9*sum/(nx-1);
	f2=  (g *(1-sqrt(zz[0]/g)) + 1) * (2.0/(1+exp(-psum)));

    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif


/*  Test problem ZDT2
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - pow((f1/g),2.0);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif


#ifdef szdt2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
	int nx=30;
	double g;
	double sum=0,psum=0,flag=0, f1, f2;
	double z[nx],zz[nx],p[nx];
	int i;
	double o[100]={0.583, 0.424, 0.516, 0.334, 0.433, 0.226, 0.580, 0.760, 0.530, 0.641, 0.209, 0.380, 0.783, 0.681, 0.461, 0.568, 0.794, 0.059, 0.603, 0.050, 0.415, 0.305, 0.874, 0.015, 0.768, 0.971, 0.990, 0.789, 0.439, 0.498, 0.214, 0.643, 0.320, 0.960, 0.727, 0.412, 0.745, 0.268, 0.440, 0.933, 0.683, 0.213, 0.839, 0.629, 0.134, 0.207, 0.607, 0.630, 0.370, 0.575, 0.451, 0.044, 0.027, 0.313, 0.013, 0.384, 0.683, 0.093, 0.035, 0.612, 0.609, 0.016, 0.016, 0.190, 0.587, 0.058, 0.368, 0.631, 0.718, 0.693, 0.084, 0.454, 0.442, 0.353, 0.154, 0.676, 0.699, 0.728, 0.478, 0.555, 0.121, 0.451, 0.716, 0.893, 0.273, 0.255, 0.866, 0.232, 0.805, 0.908, 0.232, 0.239, 0.050, 0.078, 0.641, 0.191, 0.844, 0.174, 0.171, 0.994};
	double d_l[100]={0.155, 0.119, 0.185, 0.064, 0.070, 0.203, 0.166, 0.151, 0.219, 0.083, 0.161, 0.057, 0.169, 0.072, 0.135, 0.114, 0.241, 0.129, 0.230, 0.181, 0.195, 0.058, 0.152, 0.107, 0.119, 0.219, 0.203, 0.212, 0.126, 0.238, 0.164, 0.236, 0.086, 0.087, 0.188, 0.244, 0.146, 0.124, 0.218, 0.196, 0.120, 0.140, 0.120, 0.207, 0.205, 0.114, 0.107, 0.228, 0.097, 0.208, 0.105, 0.120, 0.135, 0.196, 0.183, 0.111, 0.081, 0.236, 0.183, 0.171, 0.063, 0.160, 0.246, 0.091, 0.064, 0.188, 0.222, 0.082, 0.174, 0.114, 0.155, 0.209, 0.179, 0.130, 0.184, 0.200, 0.108, 0.143, 0.116, 0.155, 0.078, 0.189, 0.128, 0.171, 0.168, 0.226, 0.061, 0.250, 0.201, 0.226, 0.065, 0.194, 0.114, 0.159, 0.135, 0.239, 0.167, 0.204, 0.095, 0.091};
	double lamda_l[100]={3.236, 4.201, 2.701, 7.775, 7.148, 2.465, 3.020, 3.322, 2.285, 6.004, 3.106, 8.801, 2.956, 6.918, 3.708, 4.403, 2.077, 3.884, 2.171, 2.760, 2.567, 8.636, 3.299, 4.666, 4.208, 2.285, 2.469, 2.362, 3.963, 2.099, 3.052, 2.120, 5.809, 5.753, 2.654, 2.053, 3.427, 4.046, 2.297, 2.548, 4.151, 3.577, 4.165, 2.417, 2.445, 4.405, 4.668, 2.192, 5.147, 2.398, 4.743, 4.157, 3.710, 2.553, 2.733, 4.519, 6.159, 2.121, 2.738, 2.926, 7.918, 3.130, 2.034, 5.495, 7.846, 2.666, 2.253, 6.068, 2.881, 4.388, 3.220, 2.389, 2.791, 3.832, 2.711, 2.496, 4.624, 3.505, 4.297, 3.223, 6.428, 2.644, 3.920, 2.917, 2.978, 2.215, 8.138, 2.000, 2.490, 2.215, 7.711, 2.574, 4.395, 3.135, 3.705, 2.091, 3.003, 2.456, 5.241, 5.499};

	for(i=0;i<nx;i++)
	{
		z[i]=xreal[i]-o[i];
	}

	if ( z[0]>=0)
	{
		zz[0]=z[0];
		f1=zz[0]+1;
	}
	else
	{
		zz[0]= -lamda_l[0] * z[0];
		f1 = 2.0/(1+exp(z[0]/d_l[0])) * (zz[0]+1);
	}

	for(i=1;i<nx;i++)
	{
		p[i]=0;
		zz[i]=z[i];
		if (z[i]<0)
		{
			zz[i]= -lamda_l[i] * z[i];
			p[i]= -z[i]/d_l[i];
		}
		sum+=zz[i];
		psum = sqrt(pow(psum,2) + pow(p[i],2));
	}
	g = 1+9*sum/(nx-1);
	f2 =  (g * (1 - pow(zz[0]/g, 2)) + 1) * (2.0/(1+exp(-psum)));
if ( f1>=f2 ) {
    obj[0] = f1;
}
else
{
    obj[0] = f1;
}
    obj[1] = f2;
    return;
}
#endif



/*  Test problem ZDT3
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt3
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - sqrt(f1/g) - (f1/g)*sin(10.0*PI*f1);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif



/*  Test problem ZDT4
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt4
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<10; i++)
    {
        g += xreal[i]*xreal[i] - 10.0*cos(4.0*PI*xreal[i]);
    }
    g += 91.0;
    h = 1.0 - sqrt(f1/g);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif




#ifdef szdt4
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
	int nx = nreal;
	double *x = xreal;
	double *f = obj;
	double g;
	double sum=0,psum=0;
	double z[nx],zz[nx],p[nx];
	int i;
	double o[100]={0.957, 0.436, 2.092, 5.523, 5.686, 3.616, 1.646, 9.461, 0.881, 7.606, 4.401, 4.251, 5.182, 6.320, 9.136, 9.871, 7.308, 6.021, 1.941, 0.640, 0.581, 4.970, 4.677, 4.436, 3.997, 1.971, 0.071, 8.880, 9.464, 4.152, 1.318, 4.620, 9.296, 2.804, 9.034, 1.787, 5.197, 7.792, 5.364, 7.301, 0.953, 6.922, 5.955, 5.000, 1.437, 1.800, 2.796, 2.448, 0.499, 2.813, 3.784, 5.816, 7.544, 9.607, 0.634, 7.079, 6.864, 9.367, 2.498, 3.362, 5.484, 8.693, 2.720, 0.246, 1.878, 7.354, 4.399, 8.886, 1.394, 4.045, 7.694, 1.343, 4.430, 4.077, 1.512, 5.488, 7.547, 3.081, 7.321, 7.537, 3.430, 1.710, 9.287, 3.121, 5.341, 1.471, 5.165, 3.627, 7.946, 1.710, 9.013, 7.844, 9.240, 6.567, 4.996, 3.462, 1.847, 2.767, 9.231, 8.492};
	double d_l[100]={0.099, 1.905, 2.486, 1.323, 0.823, 1.519, 1.737, 1.969, 2.072, 1.949, 1.812, 1.895, 0.571, 2.378, 1.079, 0.673, 1.300, 1.929, 2.052, 1.499, 2.282, 1.721, 0.675, 1.275, 1.282, 2.080, 1.178, 1.539, 2.319, 0.672, 1.243, 0.883, 0.939, 2.239, 1.249, 1.833, 1.154, 1.773, 1.743, 2.152, 2.445, 1.783, 0.753, 1.610, 1.248, 0.749, 0.703, 1.544, 2.203, 2.355, 1.373, 1.570, 1.330, 0.834, 1.183, 0.731, 1.142, 1.991, 2.101, 1.163, 1.817, 0.849, 1.631, 0.934, 1.672, 1.313, 1.488, 0.826, 1.907, 2.250, 0.676, 0.593, 1.953, 0.699, 1.340, 1.880, 0.690, 1.655, 1.804, 2.296, 1.826, 0.856, 1.924, 1.652, 1.501, 0.903, 1.852, 1.661, 2.351, 2.107, 1.819, 0.574, 0.803, 1.662, 2.390, 2.402, 1.007, 0.654, 1.845, 2.116};
	double lamda_l[100]={5.055, 2.625, 2.011, 3.779, 6.077, 3.291, 2.878, 2.540, 2.413, 2.566, 2.760, 2.639, 8.752, 2.103, 4.633, 7.434, 3.847, 2.592, 2.437, 3.336, 2.191, 2.905, 7.409, 3.922, 3.901, 2.404, 4.245, 3.249, 2.156, 7.441, 4.024, 5.665, 5.327, 2.233, 4.003, 2.727, 4.334, 2.820, 2.869, 2.323, 2.045, 2.804, 6.644, 3.105, 4.007, 6.676, 7.116, 3.238, 2.269, 2.123, 3.642, 3.185, 3.759, 5.997, 4.228, 6.837, 4.378, 2.512, 2.380, 4.299, 2.752, 5.893, 3.066, 5.353, 2.990, 3.808, 3.360, 6.055, 2.622, 2.222, 7.394, 8.426, 2.560, 7.155, 3.732, 2.660, 7.246, 3.022, 2.772, 2.178, 2.738, 5.842, 2.599, 3.026, 3.332, 5.538, 2.700, 3.010, 2.126, 2.374, 2.748, 8.707, 6.230, 3.008, 2.092, 2.081, 4.963, 7.649, 2.710, 2.363};

	for(i=0;i<nx;i++)
	{
		z[i]=x[i]-o[i];
	}

	if ( z[0]>=0)
	{
		zz[0]=z[0];
		f[0]=zz[0]+1;
		p[0]=0;
	}
	else
	{
		zz[0]= -lamda_l[0] * z[0];
		p[0] = -z[0]/d_l[0];
		f[0] = 2.0/(1+exp(-p[0])) * (zz[0]+1);;
	}

	for (i = 1; i < nx; i++)
	{
		p[i]=0;
		zz[i]=z[i];
		if (z[i]<-5)
		{
			zz[i]=-5-lamda_l[i] * (5+z[i]);
			p[i]=(-5-z[i])/d_l[i];
		}
		sum+= zz[i] * zz[i] - 10 * cos(4 * PI * zz[i]);
		psum = sqrt(pow(psum,2) + pow(p[i],2));
	}
	g = 1 + 10 * (nx - 1) + sum;
	f[1] = (g * (1 - sqrt(zz[0] / g)) + 1) * (2.0/(1+exp(-psum)));
}
#endif



/*  Test problem ZDT5
    # of real variables = 0
    # of bin variables = 11
    # of bits for binvar1 = 30
    # of bits for binvar2-11 = 5
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt5
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    int i, j;
    int u[11];
    int v[11];
    double f1, f2, g, h;
    for (i=0; i<11; i++)
    {
        u[i] = 0;
    }
    for (j=0; j<30; j++)
    {
        if (gene[0][j] == 1)
        {
            u[0]++;
        }
    }
    for (i=1; i<11; i++)
    {
        for (j=0; j<5; j++)
        {
            if (gene[i][j] == 1)
            {
                u[i]++;
            }
        }
    }
    f1 = 1.0 + u[0];
    for (i=1; i<11; i++)
    {
        if (u[i] < 5)
        {
            v[i] = 2 + u[i];
        }
        else
        {
            v[i] = 1;
        }
    }
    g = 0;
    for (i=1; i<11; i++)
    {
        g += v[i];
    }
    h = 1.0/f1;
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT6
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt6
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
	double f1, f2, g, h;
	int i;
	f1 = 1.0 - (exp(-4.0*xreal[0]))*pow((sin(4.0*PI*xreal[0])),6.0);
	g = 0.0;
	for (i=1; i<10; i++)
	{
		g += xreal[i];
	}
	g = g/9.0;
	g = pow(g,0.25);
	g = 1.0 + 9.0*g;
	h = 1.0 - pow((f1/g),2.0);
	f2 = g*h;
	obj[0] = f1;
	obj[1] = f2;
	return;
}
#endif





#ifdef szdt6
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
	int nx = nreal;
	double *x = xreal;
	double *f = obj;
	double g;
	double sum=0,psum=0;
	double z[nx],zz[nx],p[nx];
	int i;
	double o[100] ={0.360, 0.549, 0.262, 0.597, 0.049, 0.571, 0.701, 0.962, 0.751, 0.740, 0.432, 0.634, 0.803, 0.084, 0.945, 0.916, 0.602, 0.254, 0.873, 0.513, 0.733, 0.422, 0.961, 0.072, 0.553, 0.292, 0.858, 0.336, 0.680, 0.053, 0.357, 0.498, 0.434, 0.562, 0.617, 0.113, 0.898, 0.755, 0.791, 0.815, 0.670, 0.201, 0.273, 0.626, 0.537, 0.060, 0.089, 0.271, 0.409, 0.474, 0.909, 0.596, 0.329, 0.478, 0.597, 0.161, 0.829, 0.956, 0.596, 0.029, 0.812, 0.610, 0.701, 0.092, 0.425, 0.376, 0.166, 0.833, 0.839, 0.452, 0.957, 0.147, 0.870, 0.769, 0.444, 0.621, 0.952, 0.640, 0.247, 0.353, 0.188, 0.491, 0.409, 0.464, 0.611, 0.071, 0.314, 0.608, 0.175, 0.621, 0.246, 0.587, 0.506, 0.465, 0.541, 0.942, 0.342, 0.402, 0.308, 0.412};
	double d_l[100]={0.155, 0.119, 0.185, 0.064, 0.070, 0.203, 0.166, 0.151, 0.219, 0.083, 0.161, 0.057, 0.169, 0.072, 0.135, 0.114, 0.241, 0.129, 0.230, 0.181, 0.195, 0.058, 0.152, 0.107, 0.119, 0.219, 0.203, 0.212, 0.126, 0.238, 0.164, 0.236, 0.086, 0.087, 0.188, 0.244, 0.146, 0.124, 0.218, 0.196, 0.120, 0.140, 0.120, 0.207, 0.205, 0.114, 0.107, 0.228, 0.097, 0.208, 0.105, 0.120, 0.135, 0.196, 0.183, 0.111, 0.081, 0.236, 0.183, 0.171, 0.063, 0.160, 0.246, 0.091, 0.064, 0.188, 0.222, 0.082, 0.174, 0.114, 0.155, 0.209, 0.179, 0.130, 0.184, 0.200, 0.108, 0.143, 0.116, 0.155, 0.078, 0.189, 0.128, 0.171, 0.168, 0.226, 0.061, 0.250, 0.201, 0.226, 0.065, 0.194, 0.114, 0.159, 0.135, 0.239, 0.167, 0.204, 0.095, 0.091};
	double lamda_l[100]={3.236, 4.201, 2.701, 7.775, 7.148, 2.465, 3.020, 3.322, 2.285, 6.004, 3.106, 8.801, 2.956, 6.918, 3.708, 4.403, 2.077, 3.884, 2.171, 2.760, 2.567, 8.636, 3.299, 4.666, 4.208, 2.285, 2.469, 2.362, 3.963, 2.099, 3.052, 2.120, 5.809, 5.753, 2.654, 2.053, 3.427, 4.046, 2.297, 2.548, 4.151, 3.577, 4.165, 2.417, 2.445, 4.405, 4.668, 2.192, 5.147, 2.398, 4.743, 4.157, 3.710, 2.553, 2.733, 4.519, 6.159, 2.121, 2.738, 2.926, 7.918, 3.130, 2.034, 5.495, 7.846, 2.666, 2.253, 6.068, 2.881, 4.388, 3.220, 2.389, 2.791, 3.832, 2.711, 2.496, 4.624, 3.505, 4.297, 3.223, 6.428, 2.644, 3.920, 2.917, 2.978, 2.215, 8.138, 2.000, 2.490, 2.215, 7.711, 2.574, 4.395, 3.135, 3.705, 2.091, 3.003, 2.456, 5.241, 5.499};

	for(i=0;i<nx;i++)
	{
		z[i]=x[i]-o[i];
	}

	if ( z[0]>=0)
	{
		zz[0]=z[0];
		f[0]=1 - exp(-4.0 *zz[0]) *pow(sin(6.0*PI*zz[0]),6)+1;
	}
	else
	{
		zz[0]= -lamda_l[0] * z[0];
		f[0] =  2.0/(1+exp(z[0]/d_l[0])) * (1 - exp(-4.0 *zz[0]) *pow(sin(6.0*PI*zz[0]),6) +1);
	}

	for(i=1;i<nx;i++)
	{
		p[i]=0;
		zz[i]=z[i];
		if (z[i]<0)
		{
			zz[i]=-lamda_l[i] * z[i];
			p[i]=-z[i]/d_l[i];
		}
		sum+=zz[i];
		psum = sqrt(pow(psum,2) + pow(p[i],2));
	}
	g = 1 + 9.0 * pow ( sum/(nx-1),0.25);
	f[1] =  (g * (1 - pow (( 1 - exp(-4.0 *zz[0]) * pow(sin(6.0*PI*zz[0]),6) )/g,2)) + 1 ) * (2.0/(1+exp(-psum)));
}
#endif







#ifdef ozdt6
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, g, h;
    int i;
    f1 = 1.0 - (exp(-4.0*xreal[0]))*pow((sin(4.0*PI*xreal[0])),6.0);
    g = 0.0;
    for (i=1; i<10; i++)
    {
        g += (xreal[i]);
    }
    g = g/9.0;
    g = pow(g,0.25);
    g = 1.0 + 9.0*g;
    h = 2.0 - pow((f1/g),2.0);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem BNH
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */

#ifdef bnh
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = 4.0*(xreal[0]*xreal[0] + xreal[1]*xreal[1]);
    obj[1] = pow((xreal[0]-5.0),2.0) + pow((xreal[1]-5.0),2.0);
    constr[0] = 1.0 - (pow((xreal[0]-5.0),2.0) + xreal[1]*xreal[1])/25.0;
    constr[1] = (pow((xreal[0]-8.0),2.0) + pow((xreal[1]+3.0),2.0))/7.7 - 1.0;
    return;
}
#endif

/*  Test problem OSY
    # of real variables = 6
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 6
    */

#ifdef osy
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = -(25.0*pow((xreal[0]-2.0),2.0) + pow((xreal[1]-2.0),2.0) + pow((xreal[2]-1.0),2.0) + pow((xreal[3]-4.0),2.0) + pow((xreal[4]-1.0),2.0));
    obj[1] = xreal[0]*xreal[0] +  xreal[1]*xreal[1] + xreal[2]*xreal[2] + xreal[3]*xreal[3] + xreal[4]*xreal[4] + xreal[5]*xreal[5];
    constr[0] = (xreal[0]+xreal[1])/2.0 - 1.0;
    constr[1] = 1.0 - (xreal[0]+xreal[1])/6.0;
    constr[2] = 1.0 - xreal[1]/2.0 + xreal[0]/2.0;
    constr[3] = 1.0 - xreal[0]/2.0 + 3.0*xreal[1]/2.0;
    constr[4] = 1.0 - (pow((xreal[2]-3.0),2.0))/4.0 - xreal[3]/4.0;
    constr[5] = (pow((xreal[4]-3.0),2.0))/4.0 + xreal[5]/4.0 - 1.0;
    return;
}
#endif

/*  Test problem SRN
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */

#ifdef srn
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = 2.0 + pow((xreal[0]-2.0),2.0) + pow((xreal[1]-1.0),2.0);
    obj[1] = 9.0*xreal[0] - pow((xreal[1]-1.0),2.0);
    constr[0] = 1.0 - (pow(xreal[0],2.0) + pow(xreal[1],2.0))/225.0;
    constr[1] = 3.0*xreal[1]/10.0 - xreal[0]/10.0 - 1.0;
    return;
}
#endif

/*  Test problem TNK
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */

#ifdef tnk
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    obj[0] = xreal[0];
    obj[1] = xreal[1];
    if (xreal[1] == 0.0)
    {
        constr[0] = -1.0;
    }
    else
    {
        constr[0] = xreal[0]*xreal[0] + xreal[1]*xreal[1] - 0.1*cos(16.0*atan(xreal[0]/xreal[1])) - 1.0;
    }
    constr[1] = 1.0 - 2.0*pow((xreal[0]-0.5),2.0) + 2.0*pow((xreal[1]-0.5),2.0);
    return;
}
#endif

/*  Test problem CTP1
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */

#ifdef ctp1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*exp(-obj[0]/g);
    constr[0] = obj[1]/(0.858*exp(-0.541*obj[0]))-1.0;
    constr[1] = obj[1]/(0.728*exp(-0.295*obj[0]))-1.0;
    return;
}
#endif

/*  Test problem CTP2
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.2;
    b = 10.0;
    c = 1.0;
    d = 6.0;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP3
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp3
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.1;
    b = 10.0;
    c = 1.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP4
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp4
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.75;
    b = 10.0;
    c = 1.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP5
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp5
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.1;
    b = 10.0;
    c = 2.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP6
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp6
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = 0.1*PI;
    a = 40.0;
    b = 0.5;
    c = 1.0;
    d = 2.0;
    e = -2.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP7
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */

#ifdef ctp7
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.05*PI;
    a = 40.0;
    b = 5.0;
    c = 1.0;
    d = 6.0;
    e = 0.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#endif

/*  Test problem CTP8
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */

#ifdef ctp8
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    theta = 0.1*PI;
    a = 40.0;
    b = 0.5;
    c = 1.0;
    d = 2.0;
    e = -2.0;
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    theta = -0.05*PI;
    a = 40.0;
    b = 2.0;
    c = 1.0;
    d = 6.0;
    e = 0.0;
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[1] = exp1/exp2 - 1.0;
    return;
}
#endif


#ifdef dtlz1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0;
    int i, j;
    for (i=nobj-1; i<nreal; ++i)
    {
    	g += pow(xreal[i]-0.5,2) - cos(20 * PI * (xreal[i]-0.5));
    }
    g = 100 * (nreal-nobj + g);
    for (i = 1; i <= nobj; ++i)
    {
    	f = 0.5 * (1 + g);
    	for (j = nobj - i; j > 0; --j)
		{
			f *= xreal[j-1];
		}
		if (i > 1)
		{
			f *= 1 - xreal[nobj-i]; /*xreal[(nobj - i + 1) - 1]*/
		}
    	obj[i-1] = f;
    }
    return;
}
#endif


#ifdef dtlz2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0;
    int i, j;
    for (i=nobj-1; i<nreal; ++i)
    {
        g += (xreal[i]-0.5)*(xreal[i]-0.5);
    }
    for (i = 1; i <= nobj; ++i)
	{
		f = 1 + g;
		for (j = nobj - i; j > 0; --j)
		{
			f *= cos(xreal[j-1] * PI/2);
		}
		if (i > 1)
		{
			f *= sin(xreal[nobj-i] * PI/2); /*xreal[(nobj - i + 1) - 1]*/
		}
		obj[i-1] = f;
	}
    return;
}
#endif


#ifdef mdtlz2
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f1, f2, f3, g;
    int i;
    g = 0.0;
    for (i=2; i<12; i++)
    {
        g += (xreal[i]-0.5)*(xreal[i]-0.5);
    }
    f1 = 2.0-(1-g)*cos(xreal[0]*PI/2)*cos(xreal[1]*PI/2);
    f2 = 2.0-(1-g)*cos(xreal[0]*PI/2)*sin(xreal[1]*PI/2);
    f3 = 2.0-(1-g)*sin(xreal[0]*PI/2);
    obj[0] = f1;
    obj[1] = f2;
    obj[2] = f3;
    return;
}
#endif


#ifdef dtlz3
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0;
    int i, j;
    for (i=nobj-1; i<nreal; ++i)
    {
    	g += pow(xreal[i]-0.5,2) - cos(20 * PI * (xreal[i]-0.5));
    }
    g = 100 * (nreal-nobj + g);
    for (i = 1; i <= nobj; ++i)
    {
    	f = 1 + g;
    	for (j = nobj - i; j > 0; --j)
		{
			f *= cos(xreal[j-1] * PI/2);
		}
		if (i > 1)
		{
			f *= sin(xreal[nobj-i] * PI/2); /*xreal[(nobj - i + 1) - 1]*/
		}
    	obj[i-1] = f;
    }
    return;
}
#endif


#ifdef dtlz4
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0;
    int i, j;
    int alpha = 100;
    for (i=nobj-1; i<nreal; ++i)
	{
		g += (xreal[i]-0.5)*(xreal[i]-0.5);
	}
    for (i = 1; i <= nobj; ++i)
    {
    	f = 1 + g;
    	for (j = nobj - i; j > 0; --j)
		{
			f *= cos(pow(xreal[j-1],alpha) * PI/2);
		}
		if (i > 1)
		{
			f *= sin(pow(xreal[nobj-i],alpha) * PI/2); /*xreal[(nobj - i + 1) - 1]*/
		}
    	obj[i-1] = f;
    }
    return;
}
#endif


#ifdef dtlz5
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0, t;
    int i, j;
    double theta[nobj-1];
    for (i=nobj-1; i<nreal; ++i)
    {
        g += pow(xreal[i]-0.5, 2);
    }
    t = PI / (4 * (1 + g));
	theta[0] = xreal[0] * PI/2;
	for (i = 2; i < nobj; ++i)
	{
		theta[i-1] = t * (1 + 2 * g * xreal[i-1]);
	}

    for (i = 1; i <= nobj; ++i)
	{
		f = 1 + g;
		for (j = nobj - i; j > 0; --j)
		{
			f *= cos(theta[j-1]);
		}
		if (i > 1)
		{
			f *= sin(theta[nobj-i]); /*xreal[(nobj - i + 1) - 1]*/
		}
		obj[i-1] = f;
	}
    return;
}
#endif


#ifdef dtlz6
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g=0.0, t;
    int i, j;
    double theta[nobj-1];
    for (i=nobj-1; i<nreal; ++i)
    {
        g += pow(xreal[i], 0.1);
    }
    t = PI / (4 * (1 + g));
	theta[0] = xreal[0] * PI/2;
	for (i = 2; i < nobj; ++i)
	{
		theta[i-1] = t * (1 + 2 * g * xreal[i-1]);
	}

    for (i = 1; i <= nobj; ++i)
	{
		f = 1 + g;
		for (j = nobj - i; j > 0; --j)
		{
			f *= cos(theta[j-1]);
		}
		if (i > 1)
		{
			f *= sin(theta[nobj-i]); /*xreal[(nobj - i + 1) - 1]*/
		}
		obj[i-1] = f;
	}
    return;
}
#endif


#ifdef dtlz7
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g=0.0, h=0.0;
    int i, j;
    for (i=nobj-1; i<nreal; ++i)
	{
    	g += xreal[i];
	}
    g = 1 + 9 * g / (nreal-nobj+1);
    for (i = 1; i <= nobj-1; ++i)
    {
    	obj[i-1] = xreal[i-1];
    }
    for (j = 1; j <= nobj-1; ++j)
	{
    	h += xreal[j-1] / (1 + g) * (1 + sin(3 * PI * xreal[j-1]));
	}
    h = nobj - h;
	obj[nobj-1] = (1 + g) * h;
    return;
}
#endif


#ifdef dtlz8
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f, g;
    int i, j, low, up;
    for (i = 1; i <= nobj; ++i)
    {
    	f = 0.0;
    	low = floor((i-1)*nreal/nobj) + 1;
    	up = floor(i*nreal/nobj);
    	for (j = low; j <= up ; ++j)
		{
			f += xreal[j-1];
		}
		obj[i-1] = 1 / floor(nreal/nobj) * f;
    }
    for (i = 1; i < nobj; ++i)
	{
    	g = obj[nobj-1] + 4 * obj[i-1] - 1;
    	constr[i-1] = g;
	}
    g = obj[0] + obj[1];
    for (i = 1; i < nobj-1; ++i)
    {
    	for (j = i+1; j <= nobj-1; ++j)
    	{
    		if ((obj[i-1] + obj[j-1]) < g)
    		{
    			g = obj[i-1] + obj[j-1];
    		}
    	}
    }
    constr[nobj-1] = 2 * obj[nobj-1] + g - 1;
    return;
}
#endif


#ifdef dtlz9
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double f;
    int i, j, low, up;
    for (i = 1; i <= nobj; ++i)
    {
    	f = 0.0;
    	low = floor((i-1)*nreal/nobj) + 1;
    	up = floor(i*nreal/nobj);
    	for (j = low; j <= up ; ++j)
		{
			f += pow(xreal[j-1], 0.1);
		}
		obj[i-1] = 1 / floor(nreal/nobj) * f;
    }
    for (i = 1; i < nobj; ++i)
	{
    	constr[i-1] = pow(obj[nobj-1], 2) + pow(obj[i-1], 2) - 1;
	}
    return;
}
#endif



#ifdef wfg1
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{ /*void WFG1( double *z, double *f, int nx,  int M) */
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[30],t4[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*( i+1 ));
	}
	/*y = WFG1_t1(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t1[i] = y[i];
	}
	for( i = k; i < nx; i++ )
	{
		t1[i] = s_linear( y[i], 0.35 );
	}


	/*y = WFG1_t2(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t2[i] = t1[i];
	}

	for( i = k; i < nx; i++ )
	{
		t2[i] = b_flat( t1[i], 0.8, 0.75, 0.85 );
	}

	/*y = WFG1_t3(y);*/
	for( i = 0; i < nx; i++ )
	{
		t3[i] = b_poly( t2[i], 0.02 );
	}

	/*y = WFG1_t4( y,k,M,nx);*/

	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 1; i <= nx; i++)
		{
			w[i-1] = 2.0*i;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t3[j];
				w_sub[j-head] = w[j];
			}
			t4[i-1] = r_sum( y_sub, w_sub,tail-head );
		}

		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t3[j];
			w_sub2[j-k] = w[j];
		}
		t4[i-1] = r_sum( y_sub2, w_sub2,nx-k );
	}
	/*shape*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t4[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t4[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t4[M-1];

		for( m = 1; m <= M-1; m++ )
		{
			h[m-1] = convex( x, m,M );
		}
		h[m-1] = mixed( x, 5, 1.0 );

		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg2
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[5];
	const int k=M==2?4:2*(M-1);
	const int l = nx-k;
	assert( l % 2 == 0 );

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*( i+1 ));
	}
	/*y = WFG2_t1(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t1[i] = y[i];
	}
	for( i = k; i < nx; i++ )
	{
		t1[i] = s_linear( y[i], 0.35 );
	}


	/*y = WFG2_t2(y, k);*/
	{
		double y_sub[30];
		for( i = 0; i < k; i++ )
		{
			t2[i] = t1[i];
		}

		for( i = k+1; i <= k+l/2; i++ )
		{
			const int head = k+2*( i-k )-2;
			const int tail = k+2*( i-k );
			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t1[j];
			}
			t2[i-1] = r_nonsep( y_sub, 2, 2);
		}
	}

	/*y = WFG2_t3( y,k,M);*/
	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 1; i <= nx; i++)
		{
			w[i-1] = 1.0;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t2[j];
				w_sub[j-head] = w[j];
			}
			t3[i-1] = r_sum( y_sub, w_sub, tail-head );
		}

		for( j = k; j < k+l/2; j++ )
		{
			y_sub2[j-k] = t2[j];
			w_sub2[j-k] = w[j];
		}
		t3[i-1] = r_sum( y_sub2, w_sub2, l/2 );
	}

	/*shape*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t3[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t3[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t3[M-1];

		for( m = 1; m <= M-1; m++ )
		{
			h[m-1] = convex( x, m, M );
		}
		h[m-1] = disc( x, 5, 1.0, 1.0 );

		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg3
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[5];
	const int k=M==2?4:2*(M-1);
	const int l = nx-k;
	assert( l % 2 == 0 );

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*( i+1 ));
	}
	/*y = WFG3_t1(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t1[i] = y[i];
	}
	for( i = k; i < nx; i++ )
	{
		t1[i] = s_linear( y[i], 0.35 );
	}


	/*y = WFG3_t2(y, k);*/
	{
		double y_sub[30];
		for( i = 0; i < k; i++ )
		{
			t2[i] = t1[i];
		}

		for( i = k+1; i <= k+l/2; i++ )
		{
			const int head = k+2*( i-k )-2;
			const int tail = k+2*( i-k );
			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t1[j];
			}
			t2[i-1] = r_nonsep( y_sub, 2, 2);
		}
	}

	/*y = WFG3_t3( y,k,M);*/
	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 1; i <= nx; i++)
		{
			w[i-1] = 1.0;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t2[j];
				w_sub[j-head] = w[j];
			}
			t3[i-1] = r_sum( y_sub, w_sub, tail-head );
		}

		for( j = k; j < k+l/2; j++ )
		{
			y_sub2[j-k] = t2[j];
			w_sub2[j-k] = w[j];
		}
		t3[i-1] = r_sum( y_sub2, w_sub2, l/2 );
	}

	/*shape*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 0;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t3[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t3[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t3[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = linear( x, m, M );
		}

		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg4
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*(i+1));
	}

	/*y=WFG4_t1( y );*/
	for( i = 0; i < nx; i++ )
	{
	    t1[i] = s_multi( y[i], 30, 10, 0.35 );
	}

	/*y=WFG4_t2( y, k);*/
	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 0; i < nx; i++)
		{
			w[i] = 1.0;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t1[j];
				w_sub[j-head] = w[j];
			}
			t2[i-1] = r_sum( y_sub, w_sub, tail-head );
		}

		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t1[j];
			w_sub2[j-k] = w[j];
		}
		t2[i-1] = r_sum( y_sub2, w_sub2, nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t2[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t2[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t2[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m, M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg5
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*(i+1));
	}

	/*y=WFG5_t1( y );*/
	for( i = 0; i < nx; i++ )
	{
	    t1[i] = s_decept( y[i], 0.35, 0.001, 0.05 );
	}

	/*y=WFG5_t2( y, k);*/
	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 0; i < nx; i++)
		{
			w[i] = 1.0;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t1[j];
				w_sub[j-head] = w[j];
			}
			t2[i-1] = r_sum( y_sub, w_sub, tail-head );
		}

		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t1[j];
			w_sub2[j-k] = w[j];
		}
		t2[i-1] = r_sum( y_sub2, w_sub2, nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t2[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t2[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t2[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m, M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg6
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*(i+1));
	}

	/*y = WFG6_t1(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t1[i] = y[i];
	}
	for( i = k; i < nx; i++ )
	{
		t1[i] = s_linear( y[i], 0.35 );
	}

	/*y=WFG6_t2( y, k);*/
	{
		double y_sub[30];
		double y_sub2[30];

		for( i = 1; i <= M-1; i++ )
	    {
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );
			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t1[j];
			}
			t2[i-1] = r_nonsep( y_sub, k/( M-1 ), tail-head );
	    }
		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t1[j];
		}
		t2[i-1] = r_nonsep( y_sub2, nx-k, nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t2[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t2[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t2[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m, M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg7
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*( i+1 ));
	}

	/*y= WFG7_t1( y, k);*/
	for( i = 0; i < k; i++ )
	{
		const int head = i+1;
		const int tail = nx;
		double y_sub[30],w_sub[30];
		for( j = head; j < tail; j++ )
		{
			y_sub[j-head] = y[j];
			w_sub[j-head] = 1.0;
		}
		{
			const double u = r_sum( y_sub, w_sub, tail-head );
			t1[i] = b_param( y[i], u, 0.98/49.98, 0.02, 50 );
		}
	}
	for( i = k; i < nx; i++ )
	{
		t1[i] = y[i];
	}

	/*y = WFG7_t2(y, k);*/
	for( i = 0; i < k; i++ )
	{
		t2[i] = t1[i];
	}
	for( i = k; i < nx; i++ )
	{
		t2[i] = s_linear( t1[i], 0.35 );
	}

	/*y=WFG7_t3( y, k);*/
	{
		double w[30];
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 0; i < nx; i++)
		{
			w[i] = 1.0;
		}

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t2[j];
				w_sub[j-head] = w[j];
			}
			t3[i-1] = r_sum( y_sub, w_sub, tail-head );
		}

		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t2[j];
			w_sub2[j-k] = w[j];
		}
		t3[i-1] = r_sum( y_sub2, w_sub2, nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t3[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t3[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t3[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m,M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg8
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{ /*void WFG8(double *z, double *f,int nx,int M)*/
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*(i+1));
	}

	/*y=WFG8_t1( y, k);*/
    for( i = 0; i < k; i++ )
	{
		t1[i] = y[i];
	}

	for( i = k; i < nx; i++ )
	{
		const int head = 0;
		const int tail = i;
		double y_sub[30],w_sub[30];
		for( j = head; j < tail; j++ )
		{
			y_sub[j-head] = y[j];
			w_sub[j-head] = 1;
		}
		{
			const double u = r_sum( y_sub, w_sub, tail-head );
			t1[i] = b_param( y[i], u, 0.98/49.98, 0.02, 50 );
		}

	}

	/*y=WFG1_t2( y, k);*/
	for( i = 0; i < k; i++ )
	{
		t2[i] = t1[i];
	}
	for( i = k; i < nx; i++ )
	{
		t2[i] = s_linear( t1[i], 0.35 );
	}

	/*y=WFG2_t3( y, k, M);*/
	{
		double y_sub[30],w_sub[30];
		double y_sub2[30],w_sub2[30];

		for( i = 1; i <= M-1; i++ )
		{
			const int head = ( i-1 )*k/( M-1 );
			const int tail = i*k/( M-1 );

			for( j = head; j < tail; j++ )
			{
				y_sub[j-head] = t2[j];
				w_sub[j-head] = 1;
			}
			t3[i-1] = r_sum( y_sub, w_sub,tail-head );
		}

		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t2[j];
			w_sub2[j-k] = 1;
		}
		t3[M-1] = r_sum( y_sub2, w_sub2,nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t3[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t3[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t3[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m,M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif


#ifdef wfg9
void test_problem (double *z, double *xbin, int **gene, double *f, double *constr)
{ /*void WFG9(double *z, double *f,int nx,int M)*/
	int M = nobj;
	int nx = nreal;
	int i,j;
	double y[30],t1[30],t2[30],t3[5];
	const int k=M==2?4:2*(M-1);

	for( i = 0; i < nx; i++ )
	{
		y[i] = z[i] / (2.0*( i+1 ));
	}

	/*y= WFG9_t1( y, k);*/
	for( i = 0; i < nx-1; i++ )
	{
		const int head = i+1;
		const int tail = nx;
		double y_sub[30],w_sub[30];
		for( j = head; j < tail; j++ )
		{
			y_sub[j-head] = y[j];
			w_sub[j-head] = 1;
		}
		{
			const double u = r_sum( y_sub, w_sub, tail-head );
			t1[i] = b_param( y[i], u, 0.98/49.98, 0.02, 50 );
		}
	}
	t1[nx-1]=y[nx-1];

	/*y= WFG9_t2( y, k);*/
	for( i = 0; i < k; i++ )
	{
		t2[i] = s_decept( t1[i], 0.35, 0.001, 0.05 );
	}

	for( i = k; i < nx; i++ )
	{
		t2[i] = s_multi( t1[i], 30, 95, 0.35 );
	}
	/*y= WFG9_t3( y, k, M);*/
	for( i = 1; i <= M-1; i++ )
	{
		const int head = ( i-1 )*k/( M-1 );
		const int tail = i*k/( M-1 );
		double y_sub[30];
		for( j = head; j < tail; j++ )
		{
			y_sub[j-head] = t2[j];
		}

		t3[i-1] = r_nonsep( y_sub, k/( M-1 ),tail-head );
	}

	{
		double y_sub2[30];
		for( j = k; j < nx; j++ )
		{
			y_sub2[j-k] = t2[j];
		}

		t3[M-1] = r_nonsep( y_sub2, nx-k, nx-k );
	}

	/*f_result=WFG4_shape(y);*/
	{
		int  m;
		short  A[5];
		double x[5],h[5],S[5];

		A[0] = 1;
		for( i = 1; i < M-1; i++ )
		{
			A[i] = 1;
		}
		for( i = 0; i < M-1; i++ )
		{
			double tmp1;
			tmp1 = t3[M-1];
			if( A[i] > tmp1 )
				tmp1 = A[i];
			x[i] = tmp1*( t3[i] - 0.5 ) + 0.5;
		}
		x[M-1] = t3[M-1];

		for( m = 1; m <= M; m++ )
		{
			h[m-1] = concave( x, m,M );
		}
		for( m = 1; m <= M; m++ )
		{
			S[m-1] = m*2.0;
		}

		for( i = 0; i < M; i++ )
		{
			f[i] = 1.0*x[M-1] + S[i]*h[i];
		}
	}
}
#endif

#ifdef deb2dk_4
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g, r, k;
    int i;
    k = 4.0;
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    r = 5.0 + 10.0*(xreal[0]-5.0)*(xreal[0]-5.0)+(1/k)*cos(2.0*k*PI*xreal[0]);
    obj[0] = g*r*sin(PI*xreal[0]/2.0);
    obj[1] = g*r*cos(PI*xreal[0]/2.0);
    return;
}
#endif

#ifdef deb3dk_1
void test_problem (double *xreal, double *xbin, int **gene, double *obj, double *constr)
{
    double g, r, r1, r2;
    int i;
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    r1 = 5.0 + 10.0*pow((xreal[0]-5.0),2.0)+2.0*cos(2.0*PI*xreal[0]);
    r2 = 5.0 + 10.0*pow((xreal[1]-5.0),2.0)+2.0*cos(2.0*PI*xreal[1]);
	r=(r1+r2)/2.0;
    obj[0] = g*r*sin(PI*xreal[0]/2.0)*sin(PI*xreal[1]/2.0);
    obj[1] = g*r*sin(PI*xreal[0]/2.0)*cos(PI*xreal[1]/2.0);
    obj[2] = g*r*cos(PI*xreal[0]/2.0);
    return;
}
#endif




/* functions belonging to the wfg test suite */
double correct_to_01(double aa, double epsilon)
{
	double min = 0.0, max = 1.0;
    double min_epsilon = min - epsilon;
	double max_epsilon = max + epsilon;

	if ( aa <= min && aa >= min_epsilon )
	{
		return min;
	}
	else if ( aa >= max && aa <= max_epsilon )
	{
		return max;
	}
	else
	{
		return aa;
	}
}

int vector_in_01( const double *x, int nx )
{
	int i;
	for( i = 0; i < nx; i++ )
	{
		if( x[i] < 0.0 || x[i] > 1.0 )
		{
			return 0;
		}
	}
	return 1;
}

/* Calculate the minimum of two doubles. */
static double min_double( const double aa, const double bb )
{
	return aa < bb ? aa : bb;
}

/* shape functions */
double linear( const double *x, const int m, int M )
{
	int i;
	double result = 1.0;
	for( i=1; i <= M-m; i++ )
	{
		result *= x[i-1];
	}

	if( m != 1 )
	{
		result *= 1 - x[M-m];
	}

	return correct_to_01( result, EPSILON );
}

double convex( const double *x, const int m, int M )
{
	int i;
	double result = 1.0;
	for( i=1; i <= M-m; i++ )
	{
		result *= 1.0 - cos( x[i-1]*PI/2.0 );
	}

	if( m != 1 )
	{
		result *= 1.0 - sin( x[M-m]*PI/2.0 );
	}

	return correct_to_01( result, EPSILON );
}

double concave( const double *x, const int m, int M )
{
	int i;
	double result = 1.0;

	for( i=1; i <= M-m; i++ )
	{
		result *= sin( x[i-1]*PI/2.0 );
	}

	if( m != 1 )
	{
		result *= cos( x[M-m]*PI/2.0 );
	}

	return correct_to_01( result, EPSILON );
}

double mixed( const double *x, const int A, const double  alpha )
{
	const double tmp = 2.0*A*PI;
	return correct_to_01( pow( 1.0-x[0]-cos( tmp*x[0] + PI/2.0 )/tmp, alpha ), EPSILON );
}

double disc( const double *x, const int A, const double alpha, const double beta )
{
	const double tmp1 = A*pow( x[0], beta )*PI;
	return correct_to_01( 1.0 - pow( x[0], alpha )*pow( cos( tmp1 ), 2.0 ), EPSILON );
}


/* transformation functions */
double b_poly( const double y, const double alpha )
{
	return correct_to_01( pow( y, alpha ), EPSILON );
}

double b_flat( const double y, const double A, const double B, const double C )
{
	const double tmp1 = min_double( 0.0, floor( y-B ) ) * A*( B-y )/B;
	const double tmp2 = min_double( 0.0, floor( C-y ) ) * ( 1.0-A )*( y-C )/( 1.0-C );

	return correct_to_01( A+tmp1-tmp2, EPSILON );
}

double b_param( const double y, const double u, const double A, const double B, const double C )
{
	const double v = A - ( 1.0-2.0*u )*fabs( floor( 0.5-u )+A );

	return correct_to_01( pow( y, B + ( C-B )*v ), EPSILON );
}

double s_linear( const double y, const double A )
{
	return correct_to_01( fabs( y-A )/fabs( floor( A-y )+A ), EPSILON );
}

double s_decept(const double y, const double A, const double B, const double C )
{
		const double tmp1 = floor( y-A+B )*( 1.0-C+( A-B )/B )/( A-B );
		const double tmp2 = floor( A+B-y )*( 1.0-C+( 1.0-A-B )/B )/( 1.0-A-B );

		return correct_to_01( 1.0 + ( fabs( y-A )-B )*( tmp1 + tmp2 + 1.0/B ), EPSILON );
}

double s_multi( const double y, const int A, const double B, const double C )
{
		const double tmp1 = fabs( y-C )/( 2.0*( floor( C-y )+C ) );
		const double tmp2 = ( 4.0*A+2.0 )*PI*( 0.5-tmp1 );

		return correct_to_01( ( 1.0 + cos( tmp2 ) + 4.0*B*pow( tmp1, 2.0 ) )/( B+2.0 ), EPSILON );
}

double r_sum( const double *y, const double *w, int ny)
{
	int i;
	double numerator   = 0.0;
	double denominator = 0.0;

	for( i = 0; i < ny; i++ )
	{

		numerator   += w[i]*y[i];
		denominator += w[i];
	}

	return correct_to_01( numerator / denominator, EPSILON );
}

double r_nonsep( const double *y, const int A, int ny)
{
	const int y_len = ny;
	int j;
	double numerator = 0.0;

	for( j = 0; j < y_len; j++ )
	{
		int k;
		numerator += y[j];

		for( k = 0; k <= A-2; k++ )
		{
			numerator += fabs( y[j] - y[( j+k+1 ) % y_len] );
		}
	}

	{
	const double tmp = ceil( A/2.0 );
	const double denominator = y_len*tmp*( 1.0 + 2.0*A - 2.0*tmp )/A;

	return correct_to_01( numerator / denominator, EPSILON );
	}
}

