/*This file contains the variable and function declarations for the WFG test suite */

#ifndef WFG_H_
#define WFG_H_

#define EPSILON (1.0e-10)

double correct_to_01(double aa, double epsilon);
int vector_in_01( const double *x, int nx );

/* shape functions */
double linear( const double *x, const int m,int M );
double convex( const double *x, const int m,int M );
double concave( const double *x, const int m,int M );
double mixed( const double *x, const int A, const double  alpha );
double disc( const double *x, const int A, const double alpha, const double beta );

/* transformation functions */
double b_poly( const double y, const double alpha );
double b_flat( const double y, const double A, const double B, const double C );
double b_param( const double y, const double u, const double A, const double B, const double C );
double s_linear( const double y, const double A );
double s_decept(const double y, const double A, const double B, const double C );
double s_multi( const double y, const int A, const double B, const double C );
double r_sum( const double *y, const double *w, int ny);
double r_nonsep( const double *y, const int A, int ny);

#endif /* WFG_H_ */
